// ieview.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <atlbase.h>
#include <exdisp.h>		// ShellWindows
#include <mshtml.h>		// MSHTML
#include <Tlhelp32.h>

#define _CRTDBG_MAP_ALLOC
#include <crtdbg.h>

#ifndef _DEBUG
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

//Glob vars//
long int ieHandles[32] = {0};
long int ieCrc32Page[32] = {0};

BOOL 
ListProcessModules ( 
					DWORD dwPID 
					);
BOOL 
ListProcessThreads ( 
					DWORD dwOwnerPID 
					);

int WINAPI 
GetIEContent (
				char *ie_filter, 
				char *ie_page,
				char *ie_change,
				int txt_filter,
				int html_filter,
				int ie_modules
				);

BOOL
FastCmpHandles ( long int ieHandleL,
				long int ieLocalHandles[32],
				int ieCountLocalHandles
				);

long int 
Crc32 ( LPTSTR iePage );

BOOL
CheckAnyIEContentChanges (
						long int ieHandle,
						LPTSTR ieContent
						);


void
NeedHelp ( 
		  void 
		  );

int main ( int argc, char* argv[])
{

	 if ( argc < 2 )
	{
		NeedHelp ();
		return 1;
	}
	int vCoount = 0;
	int txt_filter = 0;
	int html_filter = 0;
	int ie_modules = 0;
	char* url_filter = NULL;
	char* page_filter = NULL;
	char* change_filter = NULL;

	while ( vCoount < argc)
	{
		if ( strstr ( argv[vCoount], "-url" ) )
		{
			vCoount++;
			if ( vCoount <= argc)
			{
				int tLen = strlen ( argv[vCoount] );
				url_filter = (char *) malloc ( tLen + 1 );
				memset ( url_filter, 0, tLen + 1 );
				strncpy ( url_filter, argv[vCoount], tLen ); 
				vCoount++;
				continue;
			}
		}
		if ( strstr ( argv[vCoount], "-replace" ) )
		{
			vCoount++;
			if ( vCoount <= argc)
			{
				int tLen = strlen ( argv[vCoount] );
				change_filter = (char *) malloc ( tLen + 1 );
				memset ( change_filter, 0, tLen + 1 );
				strncpy ( change_filter, argv[vCoount], tLen ); 
				vCoount++;
				continue;
			}
		}
		if ( strstr ( argv[vCoount], "-page" ) )
		{
			vCoount++;
			if ( vCoount <= argc)
			{
				int tLen = strlen ( argv[vCoount] );
				page_filter = (char *) malloc ( tLen + 1 );
				memset ( page_filter, 0, tLen  + 1 );
				strncpy ( page_filter, argv[vCoount], tLen ); 
				vCoount++;
				continue;
			}
		}
		if ( strstr ( argv[vCoount], "-txt" ) )
		{
			vCoount++;
			txt_filter = 1;
			continue;
		}
		if ( strstr ( argv[vCoount], "-mods" ) )
		{
			vCoount++;
			ie_modules = 1;
			continue;
		}
		if ( strstr ( argv[vCoount], "-html" ) )
		{
			vCoount++;
			html_filter = 1;
			continue;
		}
		vCoount++;
	}

	CoInitialize(NULL);

	while (true)
	{
		Sleep (1);

		GetIEContent ( 
			url_filter, 
			page_filter,
			change_filter,
			txt_filter,
			html_filter,
			ie_modules
			);
	}
	CoUninitialize();
	if ( url_filter != NULL ) free ( url_filter );
	if ( page_filter != NULL ) free ( page_filter );
	if ( change_filter != NULL ) free ( change_filter );

	return 0;
}

BOOL
CheckAnyIEContentChanges (
						long int ieHandle,
						LPTSTR ieContent
						)
{
	int lCount = 0;

	while ( lCount <= 32 )
	{
		if ( ieHandles[lCount] == ieHandle )
		{
			Sleep (1);
			if ( ieCrc32Page[lCount] == Crc32( ieContent ) ) 
			{
				Sleep (1);
//printf ( "ieCrc32Page[lCount]: %d\nCrc32( ieContent ): %d\n", ieCrc32Page[lCount], Crc32( ieContent ) );
				return TRUE;
			}
			ieCrc32Page[lCount] = Crc32( ieContent );
			Sleep (1);
			return FALSE;
		}
		lCount++;
	}
	lCount = 0;
	while ( lCount <= 32 )
	{
		if ( ieHandles[lCount] == 0 )
		{
			ieHandles[lCount] = ieHandle;
			ieCrc32Page[lCount] = Crc32( ieContent );
			return FALSE;
		}
		lCount++;
	}

	ieHandles[0] = ieHandle;
	ieCrc32Page[0] = Crc32( ieContent );

	return FALSE;
}

void
NeedHelp ( 
		  void 
		  )
{
	printf ( "InternetExplorer Content Sniffer. v1.0\n" );
	printf ( "Coded by eaS7. All question on alisa@eas7.ru\n\n" );
	printf ( "This is EXAMPLE ONLY, just for fun.\n" );
	printf ( "-url \"url\"\t Sniff by url filter\n" );
	printf ( "-page \"words\"\t Sniff by page content filter\n" );
	printf ( "-replace \"words\"\t Replace ie html page content\n" );
	printf ( "-txt \t Log text only\n" );
	printf ( "-html \t Log text and html tags\n" );
	printf ( "-mods \t Output loaded IE modules and etc...\n" );
	return;
}

long int 
Crc32 ( LPTSTR iePage )
{
long int crc32Page = 0;
int pageLen = 0;
pageLen = strlen ( iePage );
while ( pageLen >= 0 )
{
	//Sleep (1);
	crc32Page += iePage[pageLen];
	pageLen--;
}
//iePage

return crc32Page;
}


int WINAPI 
GetIEContent (
				char *ie_filter, 
				char *ie_page,
				char *ie_change,
				int txt_filter,
				int html_filter,
				int ie_modules
				)
{
	long int ieLocalHandles[32] = {0};
	int ieCountLocalHandles = 0;

    

    try
    {
        CComPtr<IShellWindows> spShWin;
        if ( FAILED ( spShWin.CoCreateInstance 
					( __uuidof ( ShellWindows ) ) ) )
            throw printf ( 0,"Couldn't create object SHDocVW::ShellWindows\n" );

        LONG nCount;
        spShWin->get_Count( &nCount);


        for ( int i=0; i<nCount; i++ )
        {
            CComPtr<IDispatch> pDisp;
            spShWin->Item ( CComVariant ( i ), &pDisp );
            CComQIPtr<IWebBrowser2> pIE( pDisp );

            if ( pIE == NULL )
			{
				pIE.Release();
				pDisp.Release();
				continue;
			}

            USES_CONVERSION;
            CComBSTR bsUrl;
            //CComBSTR bsText;
            HRESULT hrz;
            try
            {
				if ( !SUCCEEDED ( pIE->get_LocationURL( &bsUrl) ) )
				{
					pIE.Release();
					pDisp.Release();
					continue;
				}
            }    
				catch(...)
            {
				pIE.Release();
				pDisp.Release();
				continue;
            }

			BSTR bstrName;
			LPTSTR lpstrName = NULL;
            try
            {
				if ( !SUCCEEDED ( pIE->get_Name( &bstrName) ) )
				{
					pIE.Release();
					pDisp.Release();
					continue;
				}
				lpstrName = W2T ( bstrName );
            }    
				catch(...)
            {
				pIE.Release();
				pDisp.Release();
				continue;
            }
			/*
			Examples:
			pIE->Stop();
			pIE->Refresh();
			pIE->Quit();
			etc...;)
			*/

pIE->Quit();				
			long pHWND = 0;
            try
            {
				if ( !SUCCEEDED ( pIE->get_HWND( &pHWND) ) ) 
				{
					pIE.Release();
					pDisp.Release();
					continue;
				}
            }    
				catch(...)
            {
				pIE.Release();
				pDisp.Release();
				continue;
            }
			ieLocalHandles[ieCountLocalHandles] = pHWND;
			ieCountLocalHandles++;
			

			BSTR bstrFullName;
			LPTSTR lpstrFullName = NULL;
            try
            {
				if ( !SUCCEEDED ( pIE->get_FullName( &bstrFullName) ) ) 
				{
					pIE.Release();
					pDisp.Release();
					continue;
				}
				lpstrFullName = W2T ( bstrFullName );
            }    
				catch(...)
            {
				pIE.Release();
				pDisp.Release();
				continue;
            }

			BSTR bstrStatusText;
			LPTSTR lpstrStatusText = NULL;
            try
            {
				if ( !SUCCEEDED ( pIE->get_StatusText( &bstrStatusText) ) ) 
				{
					pIE.Release();
					pDisp.Release();
					continue;
				}
				lpstrStatusText = W2T ( bstrStatusText );
            }    
				catch(...)
            {
				pIE.Release();
				pDisp.Release();
				continue;
            }
			

            LPTSTR lpstrUrl = W2T ( bsUrl );
			if ( ( lpstrUrl ) && ( ie_filter != NULL ) )
			{
				if ( !strstr ( lpstrUrl, ie_filter) ) 
				{
					pIE.Release();
					pDisp.Release();
					continue;
				}
			}

            CComPtr<IDispatch> pDispDoc;
            hrz = pIE->get_Document ( &pDispDoc);

            if ( !SUCCEEDED ( hrz ) ) 
			{
				pDispDoc.Release();
				pIE.Release();
				pDisp.Release();
				continue;
			}

			CComQIPtr<IHTMLDocument2> pHtmlDoc ( pDispDoc );

			if ( pHtmlDoc == NULL ) 
			{
				//pHTMLElement->Release();
				pDispDoc.Release();
				pIE.Release();
				pDisp.Release();
				continue;
			}

			IHTMLDocument2* pHTMLDocument;
			CComPtr<IHTMLElement> pHTMLElement;

			HRESULT hr = pDispDoc->QueryInterface ( IID_IHTMLDocument2,
				(void**)&pHTMLDocument );

			if ( !SUCCEEDED ( hr ) ) 
			{
				pHTMLElement.Release();
				pHTMLDocument->Release();
				pHTMLElement.Release();
				pDispDoc.Release();
			pIE.Release();
				pDisp.Release();
				continue;
			}
			/*
						CComQIPtr <IHTMLBodyElement> pHtmlBody;
					  if(SUCCEEDED(pHTMLDocument->get_body(&pHTMLElement)))     
					  {  
						if     (SUCCEEDED(pHTMLElement->QueryInterface(IID_IHTMLBodyElement,     (void**)&pHtmlBody)))  
						  pHtmlBody->put_background(L"http://img.yandex.net/i/www/logo.png");
					  }
			*/




			if ( ( !SUCCEEDED ( pHTMLDocument->get_body ( &pHTMLElement ) ) ) 
			    || ( pHTMLElement == NULL ) ) 
			{
				pHTMLElement.Release();
				pHTMLDocument->Release();
				pHTMLElement.Release();
				pDispDoc.Release();
				pIE.Release();
				pDisp.Release();
				continue;
			}

    //    CComQIPtr <IHTMLElement> pHtmlElement;
  //      pHTMLDocument->get_body (&pHtmlElement);
  
			//CComQIPtr <IHTMLBodyElement> pHtmlBody;
        //pHTMLElement->QueryInterface (IID_IHTMLBodyElement, (void**)&pHtmlBody);
        
        //CComQIPtr <IHTMLTxtRange> pTxtRange;
        //pHtmlBody->createTextRange (&pTxtRange);
        //pTxtRange->put_text (L"<html><head></head><body>Hello</body></html>");

					//	if     (SUCCEEDED(pHTMLElement->QueryInterface(IID_IHTMLBodyElement,     (void**)&pHtmlBody)))  
						  //pHtmlBody->put_background(L"http://img.yandex.net/i/www/logo.png");

		/*
		pHTMLDocument->get_body (&pHtmlElement);
        CComQIPtr <IHTMLBodyElement> pHtmlBody;
        pHtmlElement->QueryInterface (IID_IHTMLBodyElement, (void**)&pHtmlBody);
        
        CComQIPtr <IHTMLTxtRange> pTxtRange;
        pHtmlBody->createTextRange (&pTxtRange);
        pTxtRange->put_text (L"Hello");
*/

			BSTR bstrTitle;
			LPTSTR lpstrTitle = NULL;
			if ( SUCCEEDED ( pHTMLElement->get_title ( &bstrTitle ) ) )
			{
				lpstrTitle = W2T ( bstrTitle );
			}

			BSTR bstrHtml;
			LPTSTR lpstrHtml = NULL;
			try
			{
				if ( !SUCCEEDED ( pHTMLElement->get_innerHTML ( &bstrHtml ) ) ) 
				{
					pHTMLElement.Release();
					pHTMLDocument->Release();
					pHTMLElement.Release();
					pDispDoc.Release();
					pIE.Release();
					pDisp.Release();
					continue;
				}
				lpstrHtml = W2T ( bstrHtml );
			}    
			catch(...)
			{
				pHTMLElement.Release();
				pHTMLDocument->Release();
				pHTMLElement.Release();
				pDispDoc.Release();
				pIE.Release();
				pDisp.Release();
				continue;
			}

			//printf ("1 working.... %s \n", lpstrHtml);

			Sleep (1);
			if ( TRUE == CheckAnyIEContentChanges ( pHWND, lpstrHtml ) ) 
			{
				pHTMLElement.Release();
				pHTMLDocument->Release();
				pHTMLElement.Release();
				pDispDoc.Release();
				pIE.Release();
				pDisp.Release();
				continue;
			}

			BSTR bstrText;
			LPTSTR lpstrText = NULL;
			try
			{
				if ( !SUCCEEDED ( pHTMLElement->get_innerText ( &bstrText ) ) ) 
				{
					pHTMLElement.Release();
					pHTMLDocument->Release();
					pHTMLElement.Release();
					pDispDoc.Release();
					pIE.Release();
					pDisp.Release();
					continue;
				}
				lpstrText = W2T ( bstrText );
			}    
			catch(...)
			{
				pHTMLElement.Release();
				pHTMLDocument->Release();
				pHTMLElement.Release();
				pDispDoc.Release();
				pIE.Release();
				pDisp.Release();
				continue;
			}						
			
			
			
			
			if ( ( txt_filter == 1 ) && ( html_filter == 0 ) )
			{
				if ( ( lpstrText ) && ( ie_page != NULL ) )
				{
					if ( !strstr ( lpstrText, ie_page) ) 
					{
						pHTMLElement.Release();
						pHTMLDocument->Release();
						pHTMLElement.Release();
						pDispDoc.Release();
						pIE.Release();
						pDisp.Release();
						continue;
					}
				}

				if ( ie_change != NULL )
				{
					pHTMLElement.Release();
					pHTMLDocument->Release();
					pHTMLElement.Release();
					pDispDoc.Release();
					pIE.Release();
					pDisp.Release();
					continue;
				}
				if ( lpstrName != NULL ) printf ( "IE Name: %s\n", lpstrName );
				if ( lpstrFullName != NULL ) printf ( "IE FullName: %s\n", lpstrFullName );
				if ( pHWND != 0 ) 
				{
					char ieClassNameStr[256] = {0};
					char ieClassWindowTextStr[256] = {0};
					DWORD ieThreadPid;
				    GetClassName ( (HWND)pHWND, ieClassNameStr, 255 );
				    GetWindowText ( (HWND)pHWND, ieClassWindowTextStr, 255 );
					DWORD h = GetWindowThreadProcessId ( (HWND)pHWND, &ieThreadPid );
					printf ( "IE PID: %d\n", ieThreadPid );
					if ( ie_modules == 1 )
					{
						ListProcessModules( ieThreadPid );
						ListProcessThreads( ieThreadPid ) ;
					}
					printf ( "IE ClassName: %s\n", ieClassNameStr );
					printf ( "IE WindowText: %s\n", ieClassWindowTextStr );
					printf ( "IE Handle: %d\n", pHWND );
				}
				if ( lpstrStatusText != NULL ) printf ( "IE StatusText: %s\n", lpstrStatusText );
				if ( lpstrTitle != NULL ) printf ( "IE Title: %s\n", lpstrTitle );
				if ( lpstrUrl != NULL ) printf ( "IE Url: %s\n", lpstrUrl );
				if ( lpstrText != NULL ) printf ( "Text:\n%s\n", lpstrText );
				printf ( "\tWaiting for Changes...;)\n\tPress Ctrl-C for EXIT.\n" );
			}
			if ( ( ( html_filter == 1 ) && ( txt_filter == 0 ) ) ||
				 ( ( html_filter == 0 ) && ( txt_filter == 0 ) ) )
				
			{	
				if ( ( lpstrHtml ) && ( ie_page != NULL ) )
				{
					if ( !strstr ( lpstrHtml, ie_page) ) 
					{
						pHTMLElement.Release();
						pHTMLDocument->Release();
						pHTMLElement.Release();
						pDispDoc.Release();
						pIE.Release();
						pDisp.Release();
						continue;
					}
				}

				if ( ie_change != NULL )
				{
					pHTMLElement.Release();
					pHTMLDocument->Release();
					pHTMLElement.Release();
					pDispDoc.Release();
					pIE.Release();
					pDisp.Release();
					continue;
				}

				if ( lpstrName != NULL ) printf ( "IE Name: %s\n", lpstrName );
				if ( lpstrFullName != NULL ) printf ( "IE FullName: %s\n", lpstrFullName );
				if ( pHWND != 0 ) 
				{
					char ieClassNameStr[256] = {0};
					char ieClassWindowTextStr[256] = {0};
					DWORD ieThreadPid;
				    GetClassName ( (HWND)pHWND, ieClassNameStr, 255 );
				    GetWindowText ( (HWND)pHWND, ieClassWindowTextStr, 255 );
					GetWindowThreadProcessId ( (HWND)pHWND, &ieThreadPid );
					printf ( "IE PID: %d\n", ieThreadPid );
					if ( ie_modules == 1 )
					{
						ListProcessModules( ieThreadPid );
						ListProcessThreads( ieThreadPid ) ;
					}
					printf ( "IE ClassName: %s\n", ieClassNameStr );
					printf ( "IE WindowText: %s\n", ieClassWindowTextStr );
					printf ( "IE Handle: %d\n", pHWND );
				}
				if ( lpstrStatusText != NULL ) printf ( "IE StatusText: %s\n", lpstrStatusText );
				if ( lpstrTitle != NULL ) printf ( "IE Title: %s\n", lpstrTitle );
				if ( lpstrUrl != NULL ) printf ( "IE Url: %s\n", lpstrUrl );
				if ( lpstrText != NULL ) printf ( "Text:\n%s\n", lpstrText );
				if ( lpstrHtml != NULL ) printf ( "Html:\n%s\n", lpstrHtml );
				printf ( "\tWaiting for Changes...;)\n\tPress Ctrl-C for EXIT.\n" );
			}


			if ( ( html_filter == 1 ) && ( txt_filter == 1 ) ) 
			{
				if ( ( lpstrHtml ) && ( ie_page != NULL ) )
				{
					if ( !strstr ( lpstrHtml, ie_page) ) 
					{
						pHTMLElement.Release();
						pHTMLDocument->Release();
						pHTMLElement.Release();
						pDispDoc.Release();
						pIE.Release();
						pDisp.Release();
						continue;
					}
				}

				if ( ie_change != NULL )
				{
					pHTMLElement.Release();
					pHTMLDocument->Release();
					pHTMLElement.Release();
					pDispDoc.Release();
					pIE.Release();
					pDisp.Release();
					continue;
				}

				if ( lpstrName != NULL ) printf ( "IE Name: %s\n", lpstrName );
				if ( lpstrFullName != NULL ) printf ( "IE FullName: %s\n", lpstrFullName );
				if ( pHWND != 0 ) 
				{
					char ieClassNameStr[256] = {0};
					char ieClassWindowTextStr[256] = {0};
					DWORD ieThreadPid;
				    GetClassName ( (HWND)pHWND, ieClassNameStr, 255 );
				    GetWindowText ( (HWND)pHWND, ieClassWindowTextStr, 255 );
					GetWindowThreadProcessId ( (HWND)pHWND, &ieThreadPid );
					printf ( "IE PID: %d\n", ieThreadPid );
					if ( ie_modules == 1 )
					{
						ListProcessModules( ieThreadPid );
						ListProcessThreads( ieThreadPid ) ;
					}
					printf ( "IE ClassName: %s\n", ieClassNameStr );
					printf ( "IE WindowText: %s\n", ieClassWindowTextStr );
					printf ( "IE Handle: %d\n", pHWND );
				}
				if ( lpstrStatusText != NULL ) printf ( "IE StatusText: %s\n", lpstrStatusText );
				if ( lpstrTitle != NULL ) printf ( "IE Title: %s\n", lpstrTitle );
				if ( lpstrUrl != NULL ) printf ( "IE Url: %s\n", lpstrUrl );
				if ( lpstrText != NULL ) printf ( "Text:\n%s\n", lpstrText );
				if ( lpstrHtml != NULL ) printf ( "Html:\n%s\n", lpstrHtml );
				printf ( "\tWaiting for Changes...;)\n\tPress Ctrl-C for EXIT.\n" );
			}
					pHTMLElement.Release();
					pHTMLDocument->Release();
					pHTMLElement.Release();
					pDispDoc.Release();
					pIE.Release();
					pDisp.Release();

        }
		spShWin.Release();
//		pIE.Release();
		//pDisp.Release();
    }
    catch(int lpstrErr = GetLastError() ) 
	{
		printf ( "Error1...(%d)\n", lpstrErr );
        return 1;
    }
    catch(...) 
	{
        printf ( "Error2...(%d)\n", GetLastError() );
        return 1;
    }

	

    Sleep ( 10 );
	int clearCount = 0;
	Sleep (1);

	if ( ieCountLocalHandles == 0 )
	{
		while ( clearCount <= 32 )
		{
			//Sleep (1);
			ieHandles[clearCount] = 0;
			clearCount++;
		}
		return 1;
	}

	clearCount = 0;
	Sleep (1);
	while ( clearCount < 32 )
	{
		Sleep (1);
		if ( TRUE == FastCmpHandles ( 
							ieHandles[clearCount], 
							ieLocalHandles, 
							ieCountLocalHandles
							) ) 
		
		{
			ieHandles[clearCount] = 0;
			ieCrc32Page[clearCount] = 0;
		}
		clearCount++;
	}
	 _CrtSetReportMode   (_CRT_WARN,   _CRTDBG_MODE_FILE);
     _CrtSetReportFile   (_CRT_WARN,   _CRTDBG_FILE_STDOUT);
     _CrtSetReportMode   (_CRT_ERROR,  _CRTDBG_MODE_FILE);
     _CrtSetReportFile   (_CRT_ERROR,  _CRTDBG_FILE_STDOUT);
     _CrtSetReportMode   (_CRT_ASSERT, _CRTDBG_MODE_FILE);
     _CrtSetReportFile   (_CRT_ASSERT, _CRTDBG_FILE_STDOUT);
     _CrtDumpMemoryLeaks (  );

    return 1;
}

BOOL
FastCmpHandles ( long int ieHandleL,
				long int ieLocalHandles[32],
				int ieCountLocalHandles
				)
{
	Sleep (1);
	while ( ieCountLocalHandles >= 0 )
	{
		if ( ieLocalHandles[ieCountLocalHandles] == ieHandleL ) return FALSE;
		ieCountLocalHandles--;
	}

	return TRUE;
}



BOOL ListProcessModules( DWORD dwPID )
{
  HANDLE hModuleSnap = INVALID_HANDLE_VALUE;
  MODULEENTRY32 me32;

  // Take a snapshot of all modules in the specified process.
  hModuleSnap = CreateToolhelp32Snapshot( TH32CS_SNAPMODULE, dwPID );
  if( hModuleSnap == INVALID_HANDLE_VALUE )
  {
    //printError( "CreateToolhelp32Snapshot (of modules)" );
    return( FALSE );
  }

  // Set the size of the structure before using it.
  me32.dwSize = sizeof( MODULEENTRY32 );

  // Retrieve information about the first module,
  // and exit if unsuccessful
  if( !Module32First( hModuleSnap, &me32 ) )
  {
    //printError( "Module32First" );  // Show cause of failure
    CloseHandle( hModuleSnap );     // Must clean up the snapshot object!
    return( FALSE );
  }

  // Now walk the module list of the process,
  // and display information about each module
  do
  {
    printf( "\n\n     MODULE NAME:     %s",             me32.szModule );
    printf( "\n     executable     = %s",             me32.szExePath );
    printf( "\n     process ID     = 0x%08X",         me32.th32ProcessID );
    printf( "\n     ref count (g)  =     0x%04X",     me32.GlblcntUsage );
    printf( "\n     ref count (p)  =     0x%04X",     me32.ProccntUsage );
    printf( "\n     base address   = 0x%08X", (DWORD) me32.modBaseAddr );
    printf( "\n     base size      = %d",             me32.modBaseSize );

  } while( Module32Next( hModuleSnap, &me32 ) );

  CloseHandle( hModuleSnap );
  return( TRUE );
}


BOOL ListProcessThreads( DWORD dwOwnerPID ) 
{ 
  HANDLE hThreadSnap = INVALID_HANDLE_VALUE; 
  THREADENTRY32 te32; 
 
  // Take a snapshot of all running threads  
  hThreadSnap = CreateToolhelp32Snapshot( TH32CS_SNAPTHREAD, 0 ); 
  if( hThreadSnap == INVALID_HANDLE_VALUE ) 
    return( FALSE ); 
 
  // Fill in the size of the structure before using it. 
  te32.dwSize = sizeof(THREADENTRY32 ); 
 
  // Retrieve information about the first thread,
  // and exit if unsuccessful
  if( !Thread32First( hThreadSnap, &te32 ) ) 
  {
    //printError( "Thread32First" );  // Show cause of failure
    CloseHandle( hThreadSnap );     // Must clean up the snapshot object!
    return( FALSE );
  }

  // Now walk the thread list of the system,
  // and display information about each thread
  // associated with the specified process
  do 
  { 
    if( te32.th32OwnerProcessID == dwOwnerPID )
    {
      printf( "\n\n     THREAD ID      = 0x%08X", te32.th32ThreadID ); 
      printf( "\n     base priority  = %d", te32.tpBasePri ); 
      printf( "\n     delta priority = %d", te32.tpDeltaPri ); 
    }
  } while( Thread32Next(hThreadSnap, &te32 ) ); 

  CloseHandle( hThreadSnap );
  return( TRUE );
}
